import 'dart:convert';
import 'package:flutter/material.dart';
import 'package:http/http.dart' as http;
import 'Nintendo.dart';

class HomeScreen extends StatefulWidget {
  const HomeScreen({Key? key}) : super(key: key);

  @override
  State<HomeScreen> createState() => _HomeScreenState();
}

class _HomeScreenState extends State<HomeScreen> {
  List<Amiibo>? amiibos = [];

  @override
  void initState() {
    super.initState();
    fetchAmiibos();
  }

  void fetchAmiibos() async {
    print('call');
    const url = 'https://www.amiiboapi.com/api/amiibo/';
    final uri = Uri.parse(url);
    final response = await http.get(uri);
    final body = response.body;
    final json = jsonDecode(body);
    final amiiboData = Autogenerated.fromJson(json);

    setState(() {
      amiibos = amiiboData.amiibo;
    });

    print('complete');
  }

  void searchAmiibos(String searchValue) {
    setState(() {
      // If search value is empty or null, set amiibos list back to its original value
      if (searchValue.isEmpty || searchValue == null) {
        fetchAmiibos();
      } else {
        // Filter the amiibos list based on character name
        amiibos = amiibos
            ?.where((amiibo) =>
                amiibo?.character
                    ?.toLowerCase()
                    .contains(searchValue.toLowerCase()) ??
                false)
            .toList();
      }
    });
  }



  @override
  Widget build(BuildContext context) {
    return Scaffold(
      backgroundColor: Color.fromARGB(255, 45, 216, 255),
      appBar: AppBar(
        centerTitle: true,
        title: TextField(
          onChanged: (value) {
            // Call searchAmiibos method with search value
            searchAmiibos(value);
          },
          decoration: InputDecoration(
            hintText: 'Search by character',
            hintStyle: TextStyle(color: Colors.white),
            border: InputBorder.none,
          suffixIcon: GestureDetector(
              // Add a magnifying glass icon to the search box
              onTap: () {
                searchAmiibos('');
              },
              child: Icon(
                Icons.search,
                color: Colors.white,
              ),
            ),
          ),
          style: TextStyle(color: Colors.white),
        ),
        elevation: 0.0,
        backgroundColor: Color.fromARGB(255, 237, 33, 33),
      ),

      body: ListView.builder(
        itemCount: amiibos?.length ?? 0,
        itemBuilder: (context, index) {
          final amiibo = amiibos?[index];
          final imageUrl = amiibo?.image;
          final amiiboSeries = amiibo?.amiiboSeries;
          final character = amiibo?.character;
          final gameSeries = amiibo?.gameSeries;
          final head = amiibo?.head;
          final name = amiibo?.name;
          final release = amiibo?.release;
          final tail = amiibo?.tail;
          final type = amiibo?.type;
          return Padding(
            padding: EdgeInsets.all(10),
            child: Container(
              decoration: BoxDecoration(
                borderRadius: BorderRadius.circular(30),
                color: Color.fromARGB(255, 255, 255, 255),
                border: Border.all(
                  color: Color.fromARGB(255, 0, 170, 23),
                  width: 5,
                ),
              ),
              child: Row(
                // แก้ไขเป็น Row
                children: [
                  Padding(
                    padding: EdgeInsets.only(left: 10), // กำหนดขอบซ้ายของรูปภาพ
                    child: Image.network(
                      imageUrl ?? '',
                      width: 150,
                      height: 150,
                    ),
                  ),
                  Expanded(
                    child: ListTile(
                      title: Column(
                        crossAxisAlignment: CrossAxisAlignment.start,
                        children: [
                          Text(
                            'Amiibo Series: ${amiiboSeries ?? ''}',
                            style: TextStyle(
                              fontSize: 20,
                              color: Color.fromRGBO(243, 5, 5, 1),
                              fontWeight: FontWeight.bold,
                            ),
                          ),
                          Text('Character: ${character ?? ''}',style: TextStyle(
                              fontSize: 15,
                              color: Color.fromRGBO(0, 0, 0, 1),
                              fontWeight: FontWeight.bold,
                            ),),
                          Text('Game Series: ${gameSeries ?? ''}',
                            style: TextStyle(
                              fontSize: 15,
                              color: Color.fromRGBO(0, 0, 0, 1),
                              fontWeight: FontWeight.bold,
                            ),
                          ),
                          Text('Head: ${head ?? ''}',
                            style: TextStyle(
                              fontSize: 15,
                              color: Color.fromRGBO(0, 0, 0, 1),
                              fontWeight: FontWeight.bold,
                            ),
                          ),
                          Text('Name: ${name ?? ''}',
                            style: TextStyle(
                              fontSize: 15,
                              color: Color.fromRGBO(0, 0, 0, 1),
                              fontWeight: FontWeight.bold,
                            ),
                          ),
                          Text('Release: ${release ?? ''}',
                            style: TextStyle(
                              fontSize: 15,
                              color: Color.fromRGBO(0, 0, 0, 1),
                              fontWeight: FontWeight.bold,
                            ),
                          ),
                          Text('Tail: ${tail ?? ''}',
                            style: TextStyle(
                              fontSize: 15,
                              color: Color.fromRGBO(0, 0, 0, 1),
                              fontWeight: FontWeight.bold,
                            ),
                          ),
                          Text('Type: ${type ?? ''}',
                            style: TextStyle(
                              fontSize: 15,
                              color: Color.fromRGBO(0, 0, 0, 1),
                              fontWeight: FontWeight.bold,
                            ),
                          ),
                        ],
                      ),
                    ),
                  ),
                ],
              ),
            ),
          );
        },
      ),
    );
  }
}
